Index: java/main/src/main/java/com/framsticks/params/ArrayListAccess.java
===================================================================
--- java/main/src/main/java/com/framsticks/params/ArrayListAccess.java	(revision 98)
+++ java/main/src/main/java/com/framsticks/params/ArrayListAccess.java	(revision 99)
@@ -1,4 +1,5 @@
 package com.framsticks.params;
 
+import com.framsticks.params.types.ArrayListParam;
 import com.framsticks.util.UnimplementedException;
 import com.framsticks.util.lang.Numbers;
@@ -15,4 +16,5 @@
 
 	List<Object> list;
+
 
 	public ArrayListAccess(AccessInterface elementAccess) {
@@ -35,5 +37,5 @@
 			return null;
 		}
-		return Param.build().id(Integer.toString(i)).forAccess(elementAccess).finish(CompositeParam.class);
+		return paramBuilder.id(Integer.toString(i)).finish(CompositeParam.class);
 	}
 
@@ -109,8 +111,4 @@
 	}
 
-	@Override
-	public String computeIdentifierFor(Object selected) {
-		return Integer.toString(list.size());
-	}
 
 	@Override
@@ -131,5 +129,5 @@
 					@Override
 					public Param next() {
-						Param param = Param.build().id(Integer.toString(internal.nextIndex())).forAccess(elementAccess).finish();
+						Param param = paramBuilder.id(Integer.toString(internal.nextIndex())).finish(CompositeParam.class);
 						internal.next();
 						return param;
@@ -156,4 +154,8 @@
 	}
 
+	@Override
+	public ParamBuilder buildParam(ParamBuilder builder) {
+		return builder.name(containedTypeName + " list").type(ArrayListParam.class).containedTypeName(containedTypeName);
+	}
 
 }
Index: java/main/src/main/java/com/framsticks/params/EventListener.java
===================================================================
--- java/main/src/main/java/com/framsticks/params/EventListener.java	(revision 99)
+++ java/main/src/main/java/com/framsticks/params/EventListener.java	(revision 99)
@@ -0,0 +1,5 @@
+package com.framsticks.params;
+
+public interface EventListener<A> extends java.util.EventListener {
+	public void action(A argument);
+}
Index: java/main/src/main/java/com/framsticks/params/FramsClass.java
===================================================================
--- java/main/src/main/java/com/framsticks/params/FramsClass.java	(revision 98)
+++ java/main/src/main/java/com/framsticks/params/FramsClass.java	(revision 99)
@@ -5,4 +5,5 @@
 import com.framsticks.util.FramsticksException;
 import com.framsticks.util.lang.Containers;
+import com.framsticks.util.lang.Strings;
 // import com.framsticks.util.FramsticksException;
 
@@ -60,5 +61,5 @@
 
 		this.id = builder.getId();
-		this.name = builder.getName();
+		this.name = Strings.toStringEmptyProof(builder.getName(), this.id);
 		this.description = builder.getDescription();
 		this.groups = Containers.build(builder.groupBuilders);
Index: java/main/src/main/java/com/framsticks/params/FramsClassBuilder.java
===================================================================
--- java/main/src/main/java/com/framsticks/params/FramsClassBuilder.java	(revision 98)
+++ java/main/src/main/java/com/framsticks/params/FramsClassBuilder.java	(revision 99)
@@ -40,4 +40,7 @@
 
 	public static ParamBuilder induceParamType(ParamBuilder builder, Type type) {
+		// if (type.equals(Void.TYPE)) {
+		// 	throw new ConstructionException().msg("void is not a valid type");
+		// }
 
 		if (type instanceof ParameterizedType) {
@@ -47,22 +50,28 @@
 			//TODO make implementation here
 			boolean map = false;
+			StringBuilder b = new StringBuilder();
 			if (rawType.equals(Map.class)) {
 				containedType = p.getActualTypeArguments()[1];
 				map = true;
+				b.append("l");
 			} else if (rawType.equals(List.class)) {
 				containedType = p.getActualTypeArguments()[0];
+				b.append("l");
+			} else if (rawType.equals(EventListener.class)) {
+				containedType = p.getActualTypeArguments()[0];
+				b.append("e");
 			}
 			if (!(containedType instanceof Class)) {
 				return builder;
 			}
+			b.append(" ");
+
 			Class<?> containedClass = (Class<?>) containedType;
-			StringBuilder b = new StringBuilder();
-			b.append("l ");
 			FramsClassAnnotation fca = containedClass.getAnnotation(FramsClassAnnotation.class);
 			if (fca == null) {
-				log.error("the class is not annotated: " + containedClass);
-				return builder;
+				throw new ConstructionException().msg("the contained class is not annotated").arg("class", containedClass);
 			}
 			b.append(getName(fca, containedClass));
+			//TODO parametrize this
 			if (map) {
 				b.append(" name");
@@ -109,4 +118,5 @@
 				return builder;
 			}
+
 
 			// builder.type("o " + (cl).getCanonicalName());
@@ -174,5 +184,14 @@
 			}
 			if (argsNum == 1) {
-				return n.startsWith("set") ? Strings.uncapitalize(n.substring(3)) : n;
+				if (n.startsWith("set")) {
+					return Strings.uncapitalize(n.substring(3));
+				}
+				if (n.startsWith("add")) {
+					return Strings.uncapitalize(n.substring(3));
+				}
+				if (n.startsWith("remove")) {
+					return Strings.uncapitalize(n.substring(6));
+				}
+				return n;
 			}
 			log.error("invalid number of arguments");
Index: java/main/src/main/java/com/framsticks/params/InvalidOperationException.java
===================================================================
--- java/main/src/main/java/com/framsticks/params/InvalidOperationException.java	(revision 98)
+++ java/main/src/main/java/com/framsticks/params/InvalidOperationException.java	(revision 99)
@@ -1,8 +1,8 @@
 package com.framsticks.params;
 
-import com.framsticks.util.FramsticksException;
+import com.framsticks.util.UnsupportedOperationException;
 
 @SuppressWarnings("serial")
-public class InvalidOperationException extends FramsticksException {
+public class InvalidOperationException extends UnsupportedOperationException {
 
 }
Index: java/main/src/main/java/com/framsticks/params/ListAccess.java
===================================================================
--- java/main/src/main/java/com/framsticks/params/ListAccess.java	(revision 98)
+++ java/main/src/main/java/com/framsticks/params/ListAccess.java	(revision 99)
@@ -5,4 +5,5 @@
 import static com.framsticks.util.lang.Containers.filterInstanceof;
 
+import com.framsticks.params.types.EventParam;
 import com.framsticks.params.types.ProcedureParam;
 
@@ -13,7 +14,12 @@
 
 	final AccessInterface elementAccess;
+	final String containedTypeName;
+
+	protected final ParamBuilder paramBuilder;
 
 	public ListAccess(AccessInterface elementAccess) {
 		this.elementAccess = elementAccess;
+		this.containedTypeName = elementAccess.getId();
+		paramBuilder = elementAccess.buildParam(new ParamBuilder());
 	}
 
@@ -48,8 +54,4 @@
 
 	@Override
-	public void copyFrom(AccessInterface src) {
-	}
-
-	@Override
 	public void save(SinkInterface sink) {
 		for (CompositeParam p : filterInstanceof(getParams(), CompositeParam.class)) {
@@ -70,5 +72,10 @@
 	}
 
-	public abstract String computeIdentifierFor(Object selected);
+	/**
+	 * @return the containedTypeName
+	 */
+	public String getContainedTypeName() {
+		return containedTypeName;
+	}
 
 	@Override
@@ -85,11 +92,31 @@
 	@Override
 	public Object call(String id, Object[] arguments) {
-		throw new InvalidOperationException().msg("list access does not support calling methods").arg("id", id);
+		throw new InvalidOperationException().msg("list access does not support calling methods").arg("id", id).arg("access", this);
 	}
 
 	@Override
 	public Object call(ProcedureParam param, Object[] arguments) {
-		throw new InvalidOperationException().msg("list access does not support calling methods").arg("param", param);
+		throw new InvalidOperationException().msg("list access does not support calling methods").arg("param", param).arg("access", this);
 	}
 
+	@Override
+	public void reg(EventParam param, EventListener<?> listener) {
+		throw new InvalidOperationException().msg("list access does not support registering events").arg("param", param).arg("access", this);
+	}
+
+	@Override
+	public void regRemove(EventParam param, EventListener<?> listener) {
+		throw new InvalidOperationException().msg("list access does not support registering events").arg("param", param).arg("access", this);
+	}
+
+
+	@Override
+	public String toString() {
+		StringBuilder b = new StringBuilder();
+		b.append("list of ").append(containedTypeName);
+		if (getSelected() != null) {
+			b.append("[").append(getParamCount()).append("]");
+		}
+		return b.toString();
+	}
 };
Index: java/main/src/main/java/com/framsticks/params/Param.java
===================================================================
--- java/main/src/main/java/com/framsticks/params/Param.java	(revision 98)
+++ java/main/src/main/java/com/framsticks/params/Param.java	(revision 99)
@@ -97,5 +97,5 @@
 
 	public boolean isUserHidden() {
-		return (flags & Flags.USERHIDDEN) != 0;
+		return (flags & ParamFlags.USERHIDDEN) != 0;
 	}
 
Index: java/main/src/main/java/com/framsticks/params/ParamBuilder.java
===================================================================
--- java/main/src/main/java/com/framsticks/params/ParamBuilder.java	(revision 98)
+++ java/main/src/main/java/com/framsticks/params/ParamBuilder.java	(revision 99)
@@ -7,4 +7,5 @@
 import com.framsticks.util.FramsticksException;
 import com.framsticks.util.Misc;
+import com.framsticks.util.lang.FlagsUtil;
 import com.framsticks.util.lang.Strings;
 
@@ -66,5 +67,7 @@
 	private int extra = 0;
 
-	String containedTypeName;
+	protected String containedTypeName;
+
+	protected String eventArgumentTypeName;
 
 	protected Class<?> storageType;
@@ -116,4 +119,9 @@
 	}
 
+	public ParamBuilder containedTypeName(String containedTypeName) {
+		this.containedTypeName = containedTypeName;
+		return this;
+	}
+
 	/**
 	 * @return the resultType
@@ -160,4 +168,9 @@
 	public String getUid() {
 		return uid;
+	}
+
+	public ParamBuilder uid(String uid) {
+		this.uid = uid;
+		return this;
 	}
 
@@ -322,21 +335,27 @@
 			case 'e': {
 				type(EventParam.class);
-				break;
-			}
-			case 'l': {
-				containedTypeName = second;
-				if (third != null) {
-					type(UniqueListParam.class);
-					uid = third;
-				} else {
-					type(ArrayListParam.class);
-				}
-				break;
-			}
-			default:{
-				log.error("unknown type: " + first);
-				return this;
-			}
-		}
+			eventArgumentTypeName(second);
+			break;
+		}
+		case 'l': {
+			containedTypeName = second;
+			if (third != null) {
+				type(UniqueListParam.class);
+				uid = third;
+			} else {
+				type(ArrayListParam.class);
+			}
+			break;
+		}
+		default: {
+			log.error("unknown type: " + first);
+			return this;
+		}
+		}
+		return this;
+	}
+
+	public ParamBuilder eventArgumentTypeName(String eventArgumentTypeName) {
+		this.eventArgumentTypeName = eventArgumentTypeName;
 		return this;
 	}
@@ -438,5 +457,5 @@
 			id(paramEntryValues[0]);
 			group(Integer.valueOf(paramEntryValues[1]));
-			flags(Flags.read(paramEntryValues[2]));
+			flags(FlagsUtil.read(ParamFlags.class, paramEntryValues[2]));
 			name(paramEntryValues[3]);
 			type(paramEntryValues[4]);
@@ -464,5 +483,5 @@
 				break;
 			case FLAGS_FIELD:
-				flags(Flags.read(value));
+				flags(FlagsUtil.read(ParamFlags.class, value));
 				break;
 			case HELP_FIELD:
@@ -492,10 +511,13 @@
 	}
 
+	/**
+	 * @return the eventArgumentTypeName
+	 */
+	public String getEventArgumentTypeName() {
+		return eventArgumentTypeName;
+	}
+
 	public Class<?> getStorageType() {
 		return storageType;
-	}
-
-	public ParamBuilder forAccess(AccessInterface access) {
-		return name(access.getId()).type("o " + access.getId());
 	}
 
Index: java/main/src/main/java/com/framsticks/params/ParamCandidate.java
===================================================================
--- java/main/src/main/java/com/framsticks/params/ParamCandidate.java	(revision 98)
+++ java/main/src/main/java/com/framsticks/params/ParamCandidate.java	(revision 99)
@@ -73,4 +73,6 @@
 	protected final OneTime<Method> getter = new OneTime<>("getter");
 	protected final OneTime<Method> caller = new OneTime<>("caller");
+	protected final OneTime<Method> adder = new OneTime<>("adder");
+	protected final OneTime<Method> remover = new OneTime<>("remover");
 
 	protected final List<ParamAnnotation> annotations = new LinkedList<>();
@@ -142,4 +144,18 @@
 
 	/**
+	 * @return the getter
+	 */
+	public Method getAdder() {
+		return adder.get();
+	}
+
+	/**
+	 * @return the getter
+	 */
+	public Method getRemover() {
+		return remover.get();
+	}
+
+	/**
 	 * @return the annotations
 	 */
@@ -150,4 +166,10 @@
 	void validate() throws ConstructionException {
 		try {
+			if (adder.has() != remover.has()) {
+				throw new ConstructionException().msg("only one of event manipulator methods is defined");
+			}
+			if (adder.has() && remover.has()) {
+				return;
+			}
 			if (caller.has()) {
 				if (!isPublic(caller)) {
@@ -174,4 +196,9 @@
 				throw new ConstructionException().msg("missing getter or field");
 			}
+			if (getter.has() || field.has() || setter.has()) {
+				if (type.get().equals(Void.TYPE)) {
+					throw new ConstructionException().msg("type of field is void");
+				}
+			}
 		} catch (ConstructionException e) {
 			throw e.arg("in", this);
@@ -183,4 +210,7 @@
 			return false;
 		}
+		if (adder.has() || remover.has()) {
+			return false;
+		}
 		if (Collection.class.isAssignableFrom(getRawType())) {
 			return false;
@@ -197,4 +227,7 @@
 	boolean isReadOnly() {
 		if (caller.has()) {
+			return false;
+		}
+		if (adder.has() || remover.has()) {
 			return false;
 		}
@@ -229,5 +262,9 @@
 			}
 			Type[] ps = m.getGenericParameterTypes();
+			Class<?>[] pts = m.getParameterTypes();
 			if (ps.length == 0) {
+				if (m.getReturnType().equals(Void.TYPE)) {
+					throw new ConstructionException().msg("failed to add getter of void return type");
+				}
 				getter.set(m);
 				setType(m.getGenericReturnType());
@@ -235,4 +272,17 @@
 			}
 			if (ps.length == 1) {
+				if (pts[0].equals(EventListener.class)) {
+					if (member.getName().startsWith("add")) {
+						adder.set(m);
+						setType(ps[0]);
+						return;
+					}
+					if (member.getName().startsWith("remove")) {
+						remover.set(m);
+						setType(ps[0]);
+						return;
+					}
+					throw new ConstructionException().msg("invalid name of event manipulator").arg("method", m).arg("in", this);
+				}
 				setter.set(m);
 				setType(ps[0]);
@@ -251,5 +301,5 @@
 		int f = 0;
 		if (isReadOnly()) {
-			f |= Flags.READONLY;
+			f |= ParamFlags.READONLY;
 		}
 		return f;
Index: java/main/src/main/java/com/framsticks/params/ParamFlags.java
===================================================================
--- java/main/src/main/java/com/framsticks/params/ParamFlags.java	(revision 99)
+++ java/main/src/main/java/com/framsticks/params/ParamFlags.java	(revision 99)
@@ -0,0 +1,34 @@
+package com.framsticks.params;
+
+/** This class contains constants regarding parameter attributes.
+ *
+ * Based on c++ defines located in: cpp/gdk/param.h
+ *
+ * @author Jarek Szymczak <name.surname@gmail.com>
+ * (please replace name and surname with my personal data)
+ *
+ * @@author Piotr Sniegowski
+ */
+public final class ParamFlags {
+
+	public static final int READONLY = 1;
+
+	public static final int DONTSAVE = 2;
+
+	public static final int USERREADONLY = 16;
+
+	public static final int USERHIDDEN = 32;
+
+	public static final int MUTALLOCENTRY = 64;
+
+	public static final int MUTALLOCDATA = 128;
+
+	public static final int NOSTATIC = 256;
+
+	public static final int CONST = 512;
+
+	public static final int CANOMITNAME = 1024;
+
+	public static final int DONTLOAD = 2048;
+
+}
Index: java/main/src/main/java/com/framsticks/params/PropertiesAccess.java
===================================================================
--- java/main/src/main/java/com/framsticks/params/PropertiesAccess.java	(revision 98)
+++ java/main/src/main/java/com/framsticks/params/PropertiesAccess.java	(revision 99)
@@ -4,4 +4,5 @@
 import java.util.Map;
 
+import com.framsticks.params.types.EventParam;
 import com.framsticks.params.types.ProcedureParam;
 
@@ -97,10 +98,20 @@
 	@Override
 	public Object call(String id, Object[] arguments) {
-		throw new InvalidOperationException().msg("list access does not support calling methods").arg("id", id);
+		throw new InvalidOperationException().msg("properties access does not support calling methods").arg("id", id);
 	}
 
 	@Override
 	public Object call(ProcedureParam param, Object[] arguments) {
-		throw new InvalidOperationException().msg("list access does not support calling methods").arg("param", param);
+		throw new InvalidOperationException().msg("properties access does not support calling methods").arg("param", param);
+	}
+
+	@Override
+	public void reg(EventParam param, EventListener<?> listener) {
+		throw new InvalidOperationException().msg("properties access does not support registering events").arg("param", param).arg("access", this);
+	}
+
+	@Override
+	public void regRemove(EventParam param, EventListener<?> listener) {
+		throw new InvalidOperationException().msg("properties access does not support registering events").arg("param", param).arg("access", this);
 	}
 
Index: java/main/src/main/java/com/framsticks/params/ReflectionAccess.java
===================================================================
--- java/main/src/main/java/com/framsticks/params/ReflectionAccess.java	(revision 98)
+++ java/main/src/main/java/com/framsticks/params/ReflectionAccess.java	(revision 99)
@@ -17,4 +17,5 @@
 
 import com.framsticks.params.annotations.AutoAppendAnnotation;
+import com.framsticks.params.types.EventParam;
 import com.framsticks.params.types.ProcedureParam;
 import com.framsticks.util.FramsticksException;
@@ -57,7 +58,18 @@
 		}
 
+		public interface ReflectedAdder{
+			public void reg(Object object, EventListener<?> listener) throws IllegalArgumentException, IllegalAccessException, InvocationTargetException;
+		}
+
+		public interface ReflectedRemover{
+			public void regRemove(Object object, EventListener<?> listener) throws IllegalArgumentException, IllegalAccessException, InvocationTargetException;
+		}
+
 		protected final Map<ValueParam, ReflectedSetter> setters = new IdentityHashMap<>();
 		protected final Map<ValueParam, ReflectedGetter> getters = new IdentityHashMap<>();
 		protected final Map<ProcedureParam, ReflectedCaller> callers = new IdentityHashMap<>();
+		protected final Map<EventParam, ReflectedAdder> adders = new IdentityHashMap<>();
+		protected final Map<EventParam, ReflectedRemover> removers = new IdentityHashMap<>();
+
 		protected final List<Method> autoAppendMethods = new ArrayList<>();
 
@@ -100,4 +112,30 @@
 				}
 
+				for (final EventParam ep : filterInstanceof(framsClass.getParamEntries(), EventParam.class)) {
+					if (!candidates.containsKey(ep.getId())) {
+						log.trace("java class does not implement the event param " + ep);
+						continue;
+					}
+					ParamCandidate ec = candidates.get(ep.getId());
+					final Method adder = ec.getAdder();
+					final Method remover = ec.getRemover();
+
+					backend.adders.put(ep, new ReflectedAdder() {
+
+						@Override
+						public void reg(Object object, EventListener<?> listener) throws IllegalArgumentException, IllegalAccessException, InvocationTargetException {
+							adder.invoke(object, listener);
+						}
+					});
+
+					backend.removers.put(ep, new ReflectedRemover() {
+
+						@Override
+						public void regRemove(Object object, EventListener<?> listener) throws IllegalArgumentException, IllegalAccessException, InvocationTargetException {
+							remover.invoke(object, listener);
+						}
+					});
+				}
+
 				for (final ValueParam vp : filterInstanceof(framsClass.getParamEntries(), ValueParam.class)) {
 					if (!candidates.containsKey(vp.getId())) {
@@ -105,5 +143,5 @@
 					}
 					ParamCandidate pc = candidates.get(vp.getId());
-					if (pc.isReadOnly() && !vp.hasFlag(Flags.READONLY)) {
+					if (pc.isReadOnly() && !vp.hasFlag(ParamFlags.READONLY)) {
 						throw new ConstructionException().msg("readonly state conflict").arg("param", vp);
 					}
@@ -200,10 +238,8 @@
 	}
 
-	public ReflectionAccess(Class<?> reflectedClass) throws ConstructionException {
-		this(reflectedClass, FramsClass.build().forClass(reflectedClass));
-	}
-
 	public static boolean typeMatch(Class<?> a, Class<?> b) {
-		assert !b.isPrimitive();
+		if (b.isPrimitive()) {
+			throw new FramsticksException().msg("failed to match type, right argument is primitive").arg("left", a).arg("right", b);
+		}
 		if (!a.isPrimitive()) {
 			return a.equals(b);
@@ -219,14 +255,29 @@
 			return b.equals(Boolean.class);
 		}
-		assert false;
-		return false;
-	}
-
-	public ReflectionAccess(Class<?> reflectedClass, FramsClass framsClass) throws ConstructionException {
+		throw new FramsticksException().msg("failed to match types").arg("left", a).arg("right", b);
+	}
+
+
+
+
+	public ReflectionAccess(Class<?> javaClass) throws ConstructionException {
+		this(javaClass, FramsClass.build().forClass(javaClass));
+	}
+
+
+	public ReflectionAccess(Class<?> javaClass, FramsClass framsClass) throws ConstructionException {
+		this(javaClass, framsClass, Backend.getOrCreateFor(javaClass, framsClass));
+	}
+
+	protected ReflectionAccess(Class<?> javaClass, FramsClass framsClass, Backend backend) throws ConstructionException {
 		super(framsClass);
-		this.javaClass = reflectedClass;
-		this.backend = Backend.getOrCreateFor(reflectedClass, framsClass);
-	}
-
+		this.javaClass = javaClass;
+		this.backend = backend;
+	}
+
+	@Override
+	public ReflectionAccess cloneAccess() throws ConstructionException {
+		return new ReflectionAccess(javaClass, framsClass, backend);
+	}
 
 	@Override
@@ -268,4 +319,40 @@
 		} catch (FramsticksException e) {
 			throw e.arg("param", param).arg("value", value).arg("access", this);
+		}
+	}
+
+	@Override
+	public void reg(EventParam param, EventListener<?> listener) {
+		try {
+			try {
+				if (object == null) {
+					throw new FramsticksException().msg("no object set");
+				}
+
+				backend.adders.get(param).reg(object, listener);
+				return;
+			} catch (IllegalAccessException | IllegalArgumentException | InvocationTargetException e) {
+				throw new FramsticksException().msg("failed to add listener").cause(e);
+			}
+		} catch (FramsticksException e) {
+			throw e.arg("param", param).arg("access", this);
+		}
+	}
+
+	@Override
+	public void regRemove(EventParam param, EventListener<?> listener) {
+		try {
+			try {
+				if (object == null) {
+					throw new FramsticksException().msg("no object set");
+				}
+
+				backend.removers.get(param).regRemove(object, listener);
+				return;
+			} catch (IllegalAccessException | IllegalArgumentException | InvocationTargetException e) {
+				throw new FramsticksException().msg("failed to remove listener").cause(e);
+			}
+		} catch (FramsticksException e) {
+			throw e.arg("param", param).arg("access", this);
 		}
 	}
@@ -352,8 +439,4 @@
 	}
 
-	@Override
-	public ReflectionAccess cloneAccess() throws ConstructionException {
-		return new ReflectionAccess(javaClass, framsClass);
-	}
 
 	@Override
@@ -368,13 +451,4 @@
 	}
 
-	@Override
-	public String toString() {
-		StringBuilder b = new StringBuilder();
-		b.append(framsClass);
-		if (object != null) {
-			b.append("(").append(object).append(")");
-		}
-		return b.toString();
-	}
 
 	@Override
Index: java/main/src/main/java/com/framsticks/params/Registry.java
===================================================================
--- java/main/src/main/java/com/framsticks/params/Registry.java	(revision 98)
+++ java/main/src/main/java/com/framsticks/params/Registry.java	(revision 99)
@@ -46,4 +46,7 @@
 		register(javaClass);
 		associate(javaClass, putFramsClass(FramsClass.build().forClass(javaClass)));
+		for (Class<?> r : javaClass.getAnnotation(FramsClassAnnotation.class).register()) {
+			registerAndBuild(r);
+		}
 		return this;
 	}
@@ -122,4 +125,8 @@
 	}
 
+	public FramsClass getFramsClassForJavaClass(Class<?> javaClass) {
+		return javaToFramsAssociation.get(javaClass);
+	}
+
 	public Set<Class<?>> getReflectedClasses() {
 		return javaClasses.getValues();
Index: java/main/src/main/java/com/framsticks/params/SetStateFlags.java
===================================================================
--- java/main/src/main/java/com/framsticks/params/SetStateFlags.java	(revision 99)
+++ java/main/src/main/java/com/framsticks/params/SetStateFlags.java	(revision 99)
@@ -0,0 +1,20 @@
+package com.framsticks.params;
+
+/** This class contains constants regarding set operation state.
+ *
+ * Based on c++ defines located in: cpp/gdk/param.h
+ *
+ * @author Jarek Szymczak <name.surname@gmail.com>
+ * (please replace name and surname with my personal data)
+ *
+ * @@author Piotr Sniegowski
+ */
+public final class SetStateFlags {
+	public static final int PSET_RONLY = 1;
+
+	public static final int PSET_CHANGED = 2;
+
+	public static final int PSET_HITMIN = 4;
+
+	public static final int PSET_HITMAX = 8;
+}
Index: java/main/src/main/java/com/framsticks/params/SimpleAbstractAccess.java
===================================================================
--- java/main/src/main/java/com/framsticks/params/SimpleAbstractAccess.java	(revision 98)
+++ java/main/src/main/java/com/framsticks/params/SimpleAbstractAccess.java	(revision 99)
@@ -6,5 +6,7 @@
 import org.apache.log4j.Logger;
 
-import com.framsticks.util.UnimplementedException;
+import com.framsticks.params.types.ObjectParam;
+import com.framsticks.util.FramsticksException;
+import static com.framsticks.params.SetStateFlags.*;
 
 /**
@@ -105,5 +107,4 @@
 	@Override
 	public <T> int set(ValueParam param, T value) {
-		int flags = 0;
 
 		//String id = param.getEffectiveId();
@@ -115,9 +116,13 @@
 				internalSet(param, casted);
 			}
-			flags = result.getFlags();
+			return result.getFlags();
 		} catch (CastFailure e) {
-			log.error("casting failure while set: ", e);
-		}
-		return flags;
+			throw new FramsticksException()
+				.msg("casting failure while set")
+				.arg("param", param)
+				.arg("value", value)
+				.arg("value's type", (value == null ? "<null>" : value.getClass().getCanonicalName()))
+				.arg("in", this).cause(e);
+		}
 	}
 
@@ -167,16 +172,4 @@
 			set(i, max);
 		}
-	}
-
-	@Override
-	public void copyFrom(AccessInterface src) {
-		throw new UnimplementedException();
-		// clearValues();
-		//TODO: iterate over self, and pull from src
-		/*
-		for (int i = 0; i < src.getFramsClass().size(); i++) {
-			this.set(i, src.get(i, Object.class));
-		}
-		*/
 	}
 
@@ -257,10 +250,10 @@
 				continue;
 			}
-			if ((param.getFlags() & Flags.DONTLOAD) != 0) {
+			if ((param.getFlags() & ParamFlags.DONTLOAD) != 0) {
 				log.debug("DontLoad flag was set - not loading...");
 			} else {
 				int retFlags = this.set((ValueParam) param, entry.value);
-				if ((retFlags & (Flags.PSET_HITMIN | Flags.PSET_HITMAX)) != 0) {
-					String which = ((retFlags & Flags.PSET_HITMIN) != 0) ? "small" : "big";
+				if ((retFlags & (PSET_HITMIN | PSET_HITMAX)) != 0) {
+					String which = ((retFlags & PSET_HITMIN) != 0) ? "small" : "big";
 					log.warn("value of key '" + entry.key + "' was too " + which + ", adjusted");
 				}
@@ -304,4 +297,18 @@
 	}*/
 
+	@Override
+	public String toString() {
+		StringBuilder b = new StringBuilder();
+		b.append(framsClass);
+		if (getSelected() != null) {
+			b.append("(").append(getSelected()).append(")");
+		}
+		return b.toString();
+	}
+
+	@Override
+	public ParamBuilder buildParam(ParamBuilder builder) {
+		return builder.name(getId()).type(ObjectParam.class).containedTypeName(getId());
+	}
 
 }
Index: java/main/src/main/java/com/framsticks/params/UniqueListAccess.java
===================================================================
--- java/main/src/main/java/com/framsticks/params/UniqueListAccess.java	(revision 98)
+++ java/main/src/main/java/com/framsticks/params/UniqueListAccess.java	(revision 99)
@@ -1,4 +1,5 @@
 package com.framsticks.params;
 
+import com.framsticks.params.types.UniqueListParam;
 import com.framsticks.util.FramsticksException;
 import com.framsticks.util.UnimplementedException;
@@ -80,5 +81,16 @@
 			return null;
 		}
-		return Param.build().id(Integer.toString(i)).forAccess(elementAccess).finish(CompositeParam.class);
+		Iterator<Map.Entry<String, Object>> iterator = map.entrySet().iterator();
+		while (i > 0 && iterator.hasNext()) {
+			iterator.next();
+			--i;
+		}
+		if (i > 0) {
+			return null;
+		}
+		if (!iterator.hasNext()) {
+			return null;
+		}
+		return paramBuilder.id(getUidOf(iterator.next().getValue())).finish(CompositeParam.class);
 	}
 
@@ -96,5 +108,5 @@
 			return null;
 		}
-		return Param.build().id(id).forAccess(elementAccess).finish(CompositeParam.class);
+		return paramBuilder.id(id).finish(CompositeParam.class);
 	}
 
@@ -148,7 +160,4 @@
 		String uid = elementAccess.get(uidName, String.class);
 		elementAccess.select(tmp);
-		if (uid == null) {
-			return null;
-		}
 		return uid;
 	}
@@ -233,5 +242,4 @@
 	}
 
-	@Override
 	public String computeIdentifierFor(Object selected) {
 		String uid = getUidOf(selected);
@@ -260,5 +268,5 @@
 					@Override
 					public Param next() {
-						return Param.build().id(internal.next().getKey()).forAccess(elementAccess).finish();
+						return paramBuilder.id(internal.next().getKey()).finish();
 					}
 
@@ -282,3 +290,9 @@
 		return getParam(number);
 	}
+
+	@Override
+	public ParamBuilder buildParam(ParamBuilder builder) {
+		return builder.name(containedTypeName + " list").type(UniqueListParam.class).containedTypeName(containedTypeName).uid(uidName);
+	}
+
 }
Index: java/main/src/main/java/com/framsticks/params/Util.java
===================================================================
--- java/main/src/main/java/com/framsticks/params/Util.java	(revision 98)
+++ java/main/src/main/java/com/framsticks/params/Util.java	(revision 99)
@@ -36,5 +36,18 @@
 	}
 
-	public static int copyParams(AccessInterface to, AccessInterface from) {
+	public static int takeAllNonNullValues(AccessInterface to, AccessInterface from) {
+		int copied = 0;
+		for (ValueParam f : filterInstanceof(from.getParams(), ValueParam.class)) {
+			Object v = from.get(f, Object.class);
+			if (v == null) {
+				continue;
+			}
+			to.set(f, v);
+			++copied;
+		}
+		return copied;
+	}
+
+	public static int copyExistingParamsTypeSafe(AccessInterface to, AccessInterface from) {
 		int copied = 0;
 		for (ValueParam f : filterInstanceof(from.getParams(), ValueParam.class)) {
Index: java/main/src/main/java/com/framsticks/params/annotations/FramsClassAnnotation.java
===================================================================
--- java/main/src/main/java/com/framsticks/params/annotations/FramsClassAnnotation.java	(revision 98)
+++ java/main/src/main/java/com/framsticks/params/annotations/FramsClassAnnotation.java	(revision 99)
@@ -13,3 +13,4 @@
 
 	String[] order() default {};
+	Class<?>[] register() default {};
 }
Index: java/main/src/main/java/com/framsticks/params/types/EventParam.java
===================================================================
--- java/main/src/main/java/com/framsticks/params/types/EventParam.java	(revision 98)
+++ java/main/src/main/java/com/framsticks/params/types/EventParam.java	(revision 99)
@@ -12,4 +12,5 @@
 public class EventParam extends Param {
 
+	protected final String eventArgumentTypeName;
 
 
@@ -19,14 +20,15 @@
 	public EventParam(ParamBuilder builder) {
 		super(builder);
+		eventArgumentTypeName = builder.getEventArgumentTypeName();
 	}
 
 	@Override
 	public Class<?> getStorageType() {
-		return Void.class;
+		return Void.TYPE;
 	}
 
 	@Override
 	public String getFramsTypeName() {
-		return "e";
+		return eventArgumentTypeName != null ? "e " + eventArgumentTypeName : "e";
 	}
 }
